<?php
class Challenge{
    //Uchwyt połączenia
    private $link;
    //Prefix tabel
    private $prefix = "";

    //Lista id broni
    private $Weapons = array();
    //Limit
    private $LimitStart = 0;
    private $LimitNum = 15;

    //Współczynniki
    private $mulKills = 1.0;
    private $mulHS = 0.5;
    private $mulPlayed = 0.0;
    private $mulFirst = 0.0;

    //Próba połaczenia z bazą danych
    public function  __construct($host="localhost", $user="root", $pass="root", $db="challenge"){
        $this->link = @mysql_connect($host, $user, $pass);
        if(!$this->link){
            throw new Exception(mysql_error());
        }

        if(!@mysql_select_db($db, $this->link)){
            throw new Exception(mysql_error());
        }
    }
    
    public function  __destruct(){
        @mysql_close($this->link);
    }

    private function getWeaponList()
    {
		return implode( ',', $this->Weapons );
    }

    private function getSum(){
        $was = 0;
        $sum = "SUM(";
        if($this->mulKills){
            $sum .= sprintf("+(%.3f)*kills ", $this->mulKills);
            $was = 1;
        }
        if($this->mulHS){
            $sum .= sprintf("+(%.3f)*hs ", $this->mulHS);
            $was = 1;
        }
        $sum .= ")";
        if($this->mulPlayed){
            $sum .= sprintf("+(%f)*playedTime ", $this->mulPlayed);
            $was = 1;
        }
        if($this->mulFirst){
            $sum .= sprintf("+(%f)*(UNIX_TIMESTAMP()-UNIX_TIMESTAMP(firstConnect)) ", $this->mulFirst);
            $was = 1;
        }
        if(!$was)
            return "0";
        
        return $sum;
    }

   
    public function getPrefix(){
        return $this->prefix;
    }
    public function setPrefix($prefix){
        $this->prefix = $prefix;
    }

    public function buildQuery($query){
        return str_replace("#__", $this->prefix, $query);
    }
    /**
     * Włącza dane id broni do wyliczenia wyniku
     * http://wiki.amxmodx.org/CS_Weapons_Information
     *
     * @param <int> $weapons     tablica wid lub pojedyncza liczba
     */
    public function setWeapons($weapons){
        if(is_array($weapons))
            $this->Weapons = $weapons;
        else
            $this->Weapons = array($weapons);
    }

    /**
     * Ustawia limit
     *
     * @param <int> $start      początek
     * @param <int> $num        ilość
     */
    public function setLimit($start, $num = 15){
        $this->LimitStart = $start;
        $this->LimitNum = $num;
    }

    /**
     * Ustawia współczynnik zabić
     *
     * @param <float> $mul  współczynnik
     */
    public function setMultiplierKills($mul){
        $this->mulKills = $mul;
    }
    /**
     * Ustawia współczynnik headshotów
     *
     * @param <float> $mul  współczynnik
     */
    public function setMultiplierHs($mul){
        $this->mulHS = $mul;
    }
    /**
     * Ustawia współczynnik czas gry
     *
     * @param <float> $mul  współczynnik
     */
    public function setMultiplierPlayTime($mul){
        $this->mulPlayed = $mul;
    }
    /**
     * Ustawia współczynnik pierwszego podłączenia
     * 
     * @param <float> $mul  współczynnik
     */
    public function setMultiplierFirstConnect($mul){
        $this->mulFirst = $mul;
    }
    //Poprawione przez: Pavulon
    private function selectionQuery(){
        $WeaponList = $this->getWeaponList();
        $sum = $this->getSum();
        $query = "SELECT id, steamid, nickname, ip, playedTime, firstConnect, ({$sum}) AS result FROM `{$this->prefix}users`" .
                "AS u JOIN `{$this->prefix}stats` AS s ON s.pid = u.id ".
                ( $query ? "WHERE s.wid IN ({$WeaponList})" : "" ) .
				"GROUP BY id, steamid, nickname, ip, playedTime, firstConnect ".
                "ORDER BY result DESC ".
                "LIMIT {$this->LimitStart}, {$this->LimitNum}";
         return $query;
    }

    /**
     * Pobiera listę graczy
     *
     * @return <array> dane
     */
    public function getData(){
        $query = $this->selectionQuery();

        $res = mysql_query($query, $this->link);

        $data = array();
        while($row = mysql_fetch_assoc($res)){
           array_push($data, $row);
        }
        return $data;
    }
};
?>
